

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.binary_evol.binarystar &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.binary_evol.binarystar</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.binary_evol.binarystar</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;The binary object describes current and past state of the binary.</span>

<span class="sd">The binary object is composed of two star objects and contains the current and past</span>
<span class="sd">states of the binary. Only parameters in the BINARYPROPERTIES list are stored in the</span>
<span class="sd">history. The current parameter value of the star object is accessed as,</span>
<span class="sd">e.g. `binary.orbital_period` while its past history with</span>
<span class="sd">`binary.orbital_period_history`. The two stars are accesses as, e.g.</span>
<span class="sd">`binary.star_1.mass` while his past history with `binary.star_1.mass_history`.</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span>
    <span class="s1">&#39;Tassos Fragos &lt;Anastasios.Fragkos@unige.ch&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Jeff Andrews &lt;jeffrey.andrews@northwestern.edu&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Nam Tran &lt;tranhn03@gmail.com&gt;&#39;</span><span class="p">,</span> <span class="s1">&#39;Simone Bavera &lt;Simone.Bavera@unige.ch&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Emmanouil Zapartas &lt;Emmanouil.Zapartas@unige.ch&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Konstantinos Kovlakas &lt;kkovlakas@physics.uoc.gr&gt;&#39;</span>
<span class="p">]</span>

<span class="kn">import</span> <span class="nn">warnings</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">posydon.binary_evol.simulationproperties</span> <span class="kn">import</span> <span class="n">SimulationProperties</span>
<span class="kn">from</span> <span class="nn">posydon.binary_evol.singlestar</span> <span class="kn">import</span> <span class="n">SingleStar</span><span class="p">,</span> <span class="n">STARPROPERTIES</span>
<span class="kn">from</span> <span class="nn">posydon.utils.common_functions</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">check_state_of_star</span><span class="p">,</span>
    <span class="n">get_binary_state_and_event_and_mt_case</span><span class="p">,</span>
    <span class="n">get_binary_state_and_event_and_mt_case_array</span><span class="p">)</span>

<span class="c1"># star property: column names in binary history for star 1 and star 2</span>
<span class="n">STAR_ATTRIBUTES_FROM_BINARY_HISTORY</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s2">&quot;mass&quot;</span><span class="p">:</span> <span class="p">[</span><span class="s2">&quot;star_1_mass&quot;</span><span class="p">,</span> <span class="s2">&quot;star_2_mass&quot;</span><span class="p">],</span>
    <span class="s2">&quot;lg_mdot&quot;</span><span class="p">:</span> <span class="p">[</span><span class="s2">&quot;lg_mstar_dot_1&quot;</span><span class="p">,</span> <span class="s2">&quot;lg_mstar_dot_2&quot;</span><span class="p">],</span>
    <span class="s2">&quot;lg_system_mdot&quot;</span><span class="p">:</span> <span class="p">[</span><span class="s2">&quot;lg_system_mdot_1&quot;</span><span class="p">,</span> <span class="s2">&quot;lg_system_mdot_2&quot;</span><span class="p">],</span>
    <span class="s2">&quot;lg_wind_mdot&quot;</span><span class="p">:</span> <span class="p">[</span><span class="s2">&quot;lg_wind_mdot_1&quot;</span><span class="p">,</span> <span class="s2">&quot;lg_wind_mdot_2&quot;</span><span class="p">],</span>
<span class="p">}</span>

<span class="c1"># only mention those with names different from the column names in history data</span>
<span class="n">STAR_ATTRIBUTES_FROM_STAR_HISTORY</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;state&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                      <span class="c1"># to be computed after loading</span>
    <span class="s1">&#39;metallicity&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                <span class="c1"># from initial values</span>
    <span class="s1">&#39;mass&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                       <span class="c1"># from binary history</span>
    <span class="s1">&#39;lg_mdot&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                    <span class="c1"># from binary history</span>
    <span class="s1">&#39;lg_system_mdot&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>             <span class="c1"># from binary history</span>
    <span class="s1">&#39;lg_wind_mdot&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>               <span class="c1"># from binary history</span>
    <span class="s1">&#39;spin&#39;</span><span class="p">:</span> <span class="s1">&#39;spin_parameter&#39;</span><span class="p">,</span>
    <span class="s1">&#39;profile&#39;</span><span class="p">:</span> <span class="kc">None</span>
<span class="p">}</span>


<span class="n">BINARY_ATTRIBUTES_FROM_HISTORY</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;state&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;event&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;time&#39;</span><span class="p">:</span> <span class="s1">&#39;age&#39;</span><span class="p">,</span>
    <span class="s1">&#39;separation&#39;</span><span class="p">:</span> <span class="s1">&#39;binary_separation&#39;</span><span class="p">,</span>
    <span class="s1">&#39;orbital_period&#39;</span><span class="p">:</span> <span class="s1">&#39;period_days&#39;</span><span class="p">,</span>
    <span class="s1">&#39;eccentricity&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;V_sys&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;mass_transfer_case&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;nearest_neighbour_distance&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s1">&#39;p_classification&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
<span class="p">}</span>


<span class="n">BINARYPROPERTIES</span> <span class="o">=</span> <span class="p">[</span>
    <span class="s1">&#39;state&#39;</span><span class="p">,</span> <span class="c1"># the state of the system. Options can be found in function &quot;get_binary_state_and_event_and_mt_case&quot; in posydon/utils/common_functions.py</span>
    <span class="s1">&#39;event&#39;</span><span class="p">,</span> <span class="c1"># the event in the evolution of the system. Options can be found in function &quot;get_binary_state_and_event_and_mt_case&quot; in posydon/utils/common_functions.py</span>
    <span class="s1">&#39;time&#39;</span><span class="p">,</span> <span class="c1"># age of the system, in years</span>
    <span class="s1">&#39;separation&#39;</span><span class="p">,</span> <span class="c1"># binary orbital separation, in solar radii</span>
    <span class="s1">&#39;orbital_period&#39;</span><span class="p">,</span> <span class="c1"># binary orbit period, in days</span>
    <span class="s1">&#39;eccentricity&#39;</span><span class="p">,</span> <span class="c1"># binary eccentricity</span>
    <span class="s1">&#39;V_sys&#39;</span><span class="p">,</span> <span class="c1"># list of the 3 dimensions of the systemic velocity</span>
    <span class="s1">&#39;rl_relative_overflow_1&#39;</span><span class="p">,</span> <span class="c1"># (R_{star} - R_{Roche_lobe}) / R_{Roche_lobe} of star 1</span>
    <span class="s1">&#39;rl_relative_overflow_2&#39;</span><span class="p">,</span> <span class="c1"># (R_{star} - R_{Roche_lobe}) / R_{Roche_lobe} of star 2</span>
    <span class="s1">&#39;lg_mtransfer_rate&#39;</span><span class="p">,</span> <span class="c1"># log10 of abs in Msun/secyer amount of mass lost from the donor</span>
    <span class="s1">&#39;mass_transfer_case&#39;</span><span class="p">,</span> <span class="c1"># current(?) mass transfer case of the system. Options can be found in function &quot;get_binary_state_and_event_and_mt_case&quot; in posydon/utils/common_functions.py</span>
    <span class="s1">&#39;trap_radius&#39;</span><span class="p">,</span>
    <span class="s1">&#39;acc_radius&#39;</span><span class="p">,</span>
    <span class="s1">&#39;t_sync_rad_1&#39;</span><span class="p">,</span>
    <span class="s1">&#39;t_sync_conv_1&#39;</span><span class="p">,</span>
    <span class="s1">&#39;t_sync_rad_2&#39;</span><span class="p">,</span>
    <span class="s1">&#39;t_sync_conv_2&#39;</span><span class="p">,</span>
    <span class="s1">&#39;nearest_neighbour_distance&#39;</span><span class="p">,</span> <span class="c1"># the distance of system from its nearest neighbour of MESA binary system  in case of  interpolation during the the end of the previous step including MESA psygrid. The distance is normalized in the parameter space and limits at which it was calculated. See mesa_step for more details.</span>
    <span class="s1">&#39;p_classification&#39;</span> <span class="c1">#Classification probability of a binary being inside the training region</span>
<span class="p">]</span>


<div class="viewcode-block" id="BinaryStar"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar">[docs]</a><span class="k">class</span> <span class="nc">BinaryStar</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;A class containing the state and history of a stellar binary.&quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span>
                 <span class="n">star_1</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">star_2</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">index</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">properties</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="o">**</span><span class="n">binary_kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Constructor function for BinaryStar.</span>

<span class="sd">        Arguments</span>
<span class="sd">        ---------</span>
<span class="sd">        properties : SimulationProperties</span>
<span class="sd">            Instance of the SimulationProperties class (default: None)</span>
<span class="sd">        star_1 : SingleStar</span>
<span class="sd">            The first star of the binary.</span>
<span class="sd">        star_2 : Star</span>
<span class="sd">            The second star of the binary.</span>
<span class="sd">        **binary_kwargs : dictionary</span>
<span class="sd">            List of initialization parameters for a binary</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Binary Index</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">index</span> <span class="o">=</span> <span class="n">index</span>

        <span class="c1"># Create the two stars</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">star_1</span> <span class="o">=</span> <span class="n">star_1</span> <span class="k">if</span> <span class="n">star_1</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">SingleStar</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span> <span class="o">=</span> <span class="n">star_2</span> <span class="k">if</span> <span class="n">star_2</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">SingleStar</span><span class="p">()</span>

        <span class="c1"># Set the initial binary properties</span>
        <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">,</span> <span class="n">binary_kwargs</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="kc">None</span><span class="p">))</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">,</span> <span class="p">[</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">)])</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span> <span class="ow">in</span> <span class="n">binary_kwargs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;inspiral_time&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inspiral_time</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;mass_transfer_case&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mass_transfer_case</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;V_sys&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">V_sys</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;max_time&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">max_time</span> <span class="o">=</span> <span class="mf">1.3e10</span>

        <span class="c1"># Instance of SimulationProperties class - simulation parameters and parameterizations</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">properties</span><span class="p">,</span> <span class="n">SimulationProperties</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="o">=</span> <span class="n">properties</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="o">=</span> <span class="n">SimulationProperties</span><span class="p">()</span>

<div class="viewcode-block" id="BinaryStar.evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function to evolve a binary from start to finish.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">pre_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">while</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">event</span> <span class="o">!=</span> <span class="s1">&#39;END&#39;</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">event</span> <span class="o">!=</span> <span class="s1">&#39;FAILED&#39;</span>
                   <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">event</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">end_events</span>
                   <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">state</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">end_states</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">run_step</span><span class="p">()</span>
        <span class="k">finally</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span></div>

<div class="viewcode-block" id="BinaryStar.run_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.run_step">[docs]</a>    <span class="k">def</span> <span class="nf">run_step</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Evolve the binary through one evolutionary step.&quot;&quot;&quot;</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">total_state</span> <span class="o">=</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="o">.</span><span class="n">state</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="o">.</span><span class="n">state</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">state</span><span class="p">,</span>
                           <span class="bp">self</span><span class="o">.</span><span class="n">event</span><span class="p">)</span>
            <span class="n">next_step_name</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">flow</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">total_state</span><span class="p">)</span>

            <span class="k">if</span> <span class="n">next_step_name</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1">#raise ValueError(</span>
                <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span> <span class="c1"># changed it to warning and ending the evolution</span>
                    <span class="s2">&quot;Undefined next step given stars/binary state </span><span class="si">{}</span><span class="s2">.&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                        <span class="n">total_state</span><span class="p">))</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">event</span> <span class="o">=</span> <span class="s1">&#39;END&#39;</span>
                <span class="k">return</span>

            <span class="n">next_step</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="p">,</span> <span class="n">next_step_name</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">next_step</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="s2">&quot;Next step name &#39;</span><span class="si">{}</span><span class="s2">&#39; does not correspond to  function in SimulationProperties &quot;</span>
                    <span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">next_step_name</span><span class="p">))</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">next_step_name</span><span class="p">)</span>
            <span class="n">next_step</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
        <span class="k">finally</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">append_state</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span><span class="o">.</span><span class="n">post_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">next_step_name</span><span class="p">)</span></div>

<div class="viewcode-block" id="BinaryStar.append_state"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.append_state">[docs]</a>    <span class="k">def</span> <span class="nf">append_state</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Update the history of the binaries&#39; properties.&quot;&quot;&quot;</span>
        <span class="c1"># Append to the binary history lists</span>
        <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
            <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">))</span>

        <span class="c1"># Append to the individual star history lists</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="o">.</span><span class="n">append_state</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="o">.</span><span class="n">append_state</span><span class="p">()</span></div>

<div class="viewcode-block" id="BinaryStar.switch_star"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.switch_star">[docs]</a>    <span class="k">def</span> <span class="nf">switch_star</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Switch stars.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_1</span></div>

<div class="viewcode-block" id="BinaryStar.restore"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.restore">[docs]</a>    <span class="k">def</span> <span class="nf">restore</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Restore the object to the i-th state.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        i : int</span>
<span class="sd">            Index of the binary object history to reset the binary to. By default</span>
<span class="sd">            i == 0, meaning that the star will be restored to its initial state.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Move current binary properties to the ith step, using its history</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;</span><span class="si">{}</span><span class="s1">_history&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">p</span><span class="p">))[</span><span class="n">i</span><span class="p">])</span>
        <span class="k">for</span> <span class="n">star</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="p">):</span>
            <span class="n">star</span><span class="o">.</span><span class="n">restore</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

        <span class="c1"># Remove the obsolete history data</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">,</span>
                    <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">])</span></div>

<div class="viewcode-block" id="BinaryStar.reset"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.reset">[docs]</a>    <span class="k">def</span> <span class="nf">reset</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">properties</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Reset the binary to its ZAMS state.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        properties : SimulationProperties</span>
<span class="sd">            Instance of the SimulationProperties class (default: None)</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># If provided, update the simulation properties class</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">properties</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">properties</span> <span class="o">=</span> <span class="n">SimulationProperties</span><span class="p">(</span><span class="n">properties</span><span class="p">)</span>

        <span class="c1"># Use the restore function to move the binary back to its initial state</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">restore</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span></div>

<div class="viewcode-block" id="BinaryStar.to_df"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.to_df">[docs]</a>    <span class="k">def</span> <span class="nf">to_df</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return history parameters from the binary in a DataFrame.</span>
<span class="sd">        Includes star 1 and 2 (S1, S2) data and an extra column &#39;binary_index&#39;.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        extra_columns : list</span>
<span class="sd">            Extra binary parameters to return in DataFrame that are not</span>
<span class="sd">            included in BINARYPROPERTIES.</span>
<span class="sd">            Can be used in combination with `only_select_columns`.</span>
<span class="sd">            Assumes names have no suffix.</span>
<span class="sd">        ignore_columns : list</span>
<span class="sd">            Names of binary parameters to ignore.</span>
<span class="sd">            Assumes names have `_history` suffix.</span>
<span class="sd">        only_select_columns : list</span>
<span class="sd">            Names of the only columns to include.</span>
<span class="sd">            Assumes names have `_history` suffix.</span>
<span class="sd">            Can be used in combination with `extra_columns`.</span>
<span class="sd">        null_value : float</span>
<span class="sd">            Replace all None values with something else (for saving).</span>
<span class="sd">            Default is np.NAN.</span>
<span class="sd">        include_S1, include_S2 : bool</span>
<span class="sd">            Choose to include star 1 or 2 data to the DataFrame.</span>
<span class="sd">            The default is to include both.</span>
<span class="sd">        S1_kwargs, S2_kwargs : dict</span>
<span class="sd">            Kwargs to pass to each star&#39;s &#39;to_df&#39; method. (Extra and ignore columns)</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        pandas DataFrame</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">all_keys</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;binary_index&quot;</span><span class="p">]</span> \
                   <span class="o">+</span> <span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">]</span> \
                   <span class="o">+</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_columns&#39;</span><span class="p">,</span> <span class="p">[]))</span>

        <span class="n">ignore_cols</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;ignore_columns&#39;</span><span class="p">,[]))</span>
        <span class="n">keys_to_save</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">all_keys</span> \
                        <span class="k">if</span> <span class="ow">not</span> <span class="p">((</span><span class="n">i</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="n">ignore_cols</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">i</span> <span class="ow">in</span> <span class="n">ignore_cols</span><span class="p">))</span> <span class="p">]</span>

        <span class="k">if</span> <span class="nb">bool</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;only_select_columns&#39;</span><span class="p">)):</span>
            <span class="n">user_keys_to_save</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;only_select_columns&#39;</span><span class="p">))</span>
            <span class="n">keys_to_save</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;binary_index&quot;</span><span class="p">]</span> \
                            <span class="o">+</span> <span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">user_keys_to_save</span><span class="p">]</span> \
                            <span class="o">+</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_columns&#39;</span><span class="p">,</span> <span class="p">[]))</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">data_to_save</span> <span class="o">=</span> <span class="p">[</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">index</span><span class="p">]</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">state_history</span><span class="p">)</span> <span class="p">]</span> \
                           <span class="o">+</span> <span class="p">[</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">)</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys_to_save</span><span class="p">[</span><span class="mi">1</span><span class="p">:]]</span>
            <span class="n">where_none</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span> <span class="p">[</span><span class="kc">True</span> <span class="k">if</span> <span class="n">var</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">False</span> <span class="k">for</span> <span class="n">var</span> <span class="ow">in</span> <span class="n">column</span><span class="p">]</span>
                                     <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">data_to_save</span><span class="p">],</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">)</span>

        <span class="k">except</span> <span class="ne">AttributeError</span> <span class="k">as</span> <span class="n">err</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">AttributeError</span><span class="p">(</span> <span class="nb">str</span><span class="p">(</span><span class="n">err</span><span class="p">)</span> \
                    <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n\n</span><span class="s2">Available attributes in BinaryStar: </span><span class="se">\n</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__dict__</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="p">)</span>

        <span class="c1"># Convert None to np.NAN by default</span>
        <span class="n">bin_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">data_to_save</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
        <span class="n">bin_data</span><span class="p">[</span><span class="n">where_none</span><span class="p">]</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;null_value&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">NAN</span><span class="p">)</span>

        <span class="n">bin_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">bin_data</span><span class="p">)</span>

        <span class="c1"># bin_data = np.array(data_to_save, dtype=object).T</span>
        <span class="c1"># converted_bin_data = np.where( bin_data == None,</span>
        <span class="c1">#                               kwargs.get(&#39;null_value&#39;, np.NAN), bin_data)</span>
        <span class="c1"># remove the _history at the end of all column names</span>
        <span class="n">column_names</span> <span class="o">=</span> <span class="p">[</span><span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">keys_to_save</span> <span class="p">]</span>
        <span class="n">bin_df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">bin_data</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="n">column_names</span><span class="p">)</span>

        <span class="n">frames</span> <span class="o">=</span> <span class="p">[</span><span class="n">bin_df</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;include_S1&#39;</span><span class="p">,</span> <span class="kc">True</span><span class="p">):</span>
            <span class="n">frames</span><span class="o">.</span><span class="n">append</span><span class="p">(</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="o">.</span><span class="n">to_df</span><span class="p">(</span><span class="n">prefix</span><span class="o">=</span><span class="s1">&#39;S1_&#39;</span><span class="p">,</span>
                                             <span class="n">null_value</span><span class="o">=</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;null_value&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">NAN</span><span class="p">),</span>
                                             <span class="o">**</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;S1_kwargs&#39;</span><span class="p">,{}))</span> <span class="p">)</span>
        <span class="k">if</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;include_S2&#39;</span><span class="p">,</span> <span class="kc">True</span><span class="p">):</span>
            <span class="n">frames</span><span class="o">.</span><span class="n">append</span><span class="p">(</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="o">.</span><span class="n">to_df</span><span class="p">(</span><span class="n">prefix</span><span class="o">=</span><span class="s1">&#39;S2_&#39;</span><span class="p">,</span>
                                             <span class="n">null_value</span><span class="o">=</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;null_value&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">NAN</span><span class="p">),</span>
                                             <span class="o">**</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;S2_kwargs&#39;</span><span class="p">,{}))</span> <span class="p">)</span>
        <span class="k">return</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">(</span><span class="n">frames</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span></div>

<div class="viewcode-block" id="BinaryStar.from_df"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.from_df">[docs]</a>    <span class="nd">@classmethod</span>
    <span class="k">def</span> <span class="nf">from_df</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dataframe</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Convert a binary from a pandas DataFrame to BinaryStar</span>
<span class="sd">        instance.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        dataframe : Pandas DataFrame</span>
<span class="sd">            data to turn into a BinaryStar instance.</span>
<span class="sd">        index : int, optional</span>
<span class="sd">            Sets the binary index.</span>
<span class="sd">        extra_columns : list, optional</span>
<span class="sd">            Column names to be added directly to binary</span>
<span class="sd">            not in BINARYPROPERTIES.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">            New instance of BinaryStar</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># split input dataframe into kwargs dicts</span>
        <span class="n">binary_params</span><span class="p">,</span> <span class="n">star1_params</span><span class="p">,</span> <span class="n">star2_params</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(),</span> <span class="nb">dict</span><span class="p">(),</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">extra_params</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">extra_columns</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_columns&#39;</span><span class="p">,</span> <span class="p">[])</span>
        <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="nb">list</span><span class="p">(</span><span class="n">dataframe</span><span class="o">.</span><span class="n">columns</span><span class="p">):</span>
            <span class="k">if</span> <span class="s1">&#39;S1&#39;</span> <span class="ow">in</span> <span class="n">name</span><span class="p">:</span>
                <span class="n">corr_name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;S1_&#39;</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span>
                <span class="n">star1_params</span><span class="p">[</span><span class="n">corr_name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="n">name</span><span class="p">])</span>
            <span class="k">elif</span> <span class="s1">&#39;S2&#39;</span> <span class="ow">in</span> <span class="n">name</span><span class="p">:</span>
                <span class="n">corr_name</span> <span class="o">=</span> <span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;S2_&#39;</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span>
                <span class="n">star2_params</span><span class="p">[</span><span class="n">corr_name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="n">name</span><span class="p">])</span>
            <span class="k">elif</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">extra_columns</span><span class="p">:</span>
                <span class="c1"># this assumes extra cols in binary, not star 1 or 2</span>
                <span class="n">extra_params</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="n">name</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">corr_name</span> <span class="o">=</span> <span class="n">name</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span>
                <span class="n">binary_params</span><span class="p">[</span><span class="n">corr_name</span><span class="p">]</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="n">name</span><span class="p">])</span>

        <span class="n">binary</span> <span class="o">=</span> <span class="bp">cls</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;index&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">),</span>
                     <span class="n">star_1</span><span class="o">=</span><span class="n">SingleStar</span><span class="p">(</span><span class="o">**</span><span class="n">star1_params</span><span class="p">),</span>
                     <span class="n">star_2</span><span class="o">=</span><span class="n">SingleStar</span><span class="p">(</span><span class="o">**</span><span class="n">star2_params</span><span class="p">),</span>
                     <span class="o">**</span><span class="n">binary_params</span><span class="p">)</span>

        <span class="c1"># set extra history columns directly</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span> <span class="ow">in</span> <span class="n">extra_params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>

        <span class="c1"># set the binary, star1, star2 parameters to last history value in dataframe</span>
        <span class="n">all_history_lengths</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">params</span><span class="p">,</span> <span class="n">pointer</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span> <span class="p">[</span><span class="n">star1_params</span><span class="p">,</span>  <span class="n">star2_params</span><span class="p">,</span>  <span class="n">binary_params</span><span class="p">],</span>
                                    <span class="p">[</span><span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="p">,</span> <span class="n">binary</span><span class="p">]</span> <span class="p">):</span>
            <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">pointer</span><span class="p">,</span> <span class="n">key</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">],</span> <span class="n">val</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="p">)</span>
                <span class="n">all_history_lengths</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">val</span><span class="p">))</span>

        <span class="c1"># make sure all history columns have equal length</span>
        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">all_history_lengths</span><span class="p">))</span> <span class="o">==</span> <span class="mi">1</span>
        <span class="n">len_history</span> <span class="o">=</span> <span class="n">all_history_lengths</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>

        <span class="c1"># make BINARYPROPERTIES, history columns same length if not given</span>
        <span class="n">already_included_cols</span> <span class="o">=</span><span class="p">[</span><span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">binary_params</span><span class="o">.</span><span class="n">keys</span><span class="p">()]</span>
        <span class="n">valid_binaryprop_keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">p</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span> <span class="k">if</span> <span class="ow">not</span><span class="p">(</span><span class="n">p</span> <span class="ow">in</span> <span class="n">already_included_cols</span><span class="p">)]</span>
        <span class="k">for</span> <span class="n">prop_key</span> <span class="ow">in</span> <span class="n">valid_binaryprop_keys</span><span class="p">:</span>
            <span class="n">last_default_value</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">len_default</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">))</span>
            <span class="n">diff</span> <span class="o">=</span> <span class="n">len_history</span> <span class="o">-</span> <span class="n">len_default</span>
            <span class="nb">getattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">extend</span><span class="p">([</span><span class="n">last_default_value</span><span class="p">]</span><span class="o">*</span><span class="n">diff</span><span class="p">)</span>

        <span class="c1"># make STARPROPERTIES, history columns same length if not given</span>
        <span class="k">for</span> <span class="n">params</span><span class="p">,</span> <span class="n">star</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">([</span><span class="n">star1_params</span><span class="p">,</span> <span class="n">star2_params</span><span class="p">],</span> <span class="p">[</span><span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="p">]):</span>
            <span class="n">already_included_cols</span> <span class="o">=</span><span class="p">[</span><span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">params</span><span class="o">.</span><span class="n">keys</span><span class="p">()]</span>
            <span class="n">valid_starprop_keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">p</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span> <span class="k">if</span> <span class="ow">not</span><span class="p">(</span><span class="n">p</span> <span class="ow">in</span> <span class="n">already_included_cols</span><span class="p">)]</span>
            <span class="k">for</span> <span class="n">prop_key</span> <span class="ow">in</span> <span class="n">valid_starprop_keys</span><span class="p">:</span>
                <span class="n">last_default_value</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
                <span class="n">len_default</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">))</span>
                <span class="n">diff</span> <span class="o">=</span> <span class="n">len_history</span> <span class="o">-</span> <span class="n">len_default</span>
                <span class="nb">getattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">prop_key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">extend</span><span class="p">([</span><span class="n">last_default_value</span><span class="p">]</span><span class="o">*</span><span class="n">diff</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">binary</span></div>



    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the object representation when print is called.&quot;&quot;&quot;</span>
        <span class="n">s</span> <span class="o">=</span> <span class="s1">&#39;&lt;</span><span class="si">{}</span><span class="s1">.</span><span class="si">{}</span><span class="s1"> at </span><span class="si">{}</span><span class="s1">&gt;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__module__</span><span class="p">,</span>
                                     <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="nb">hex</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="p">)))</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;error_message&quot;</span><span class="p">):</span>
            <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;BINARY FAILED: </span><span class="si">{}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">error_message</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;warning_message&quot;</span><span class="p">):</span>
            <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;WARNING FOUND: </span><span class="si">{}</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">warning_message</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
            <span class="n">s</span> <span class="o">+=</span> <span class="s1">&#39;</span><span class="si">{}</span><span class="s1">: </span><span class="si">{}</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">p</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span><span class="p">))</span>
        <span class="k">for</span> <span class="n">star</span> <span class="ow">in</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">star_2</span><span class="p">):</span>
            <span class="n">s</span> <span class="o">+=</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="si">{}</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">star</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">s</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

<div class="viewcode-block" id="BinaryStar.from_run"><a class="viewcode-back" href="../../../api/posydon.binary_evol.binarystar.html#posydon.binary_evol.binarystar.BinaryStar.from_run">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">from_run</span><span class="p">(</span><span class="n">run</span><span class="p">,</span> <span class="n">history</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">profiles</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Create a BinaryStar object from a PSyGrid run.&quot;&quot;&quot;</span>
        <span class="n">binary</span> <span class="o">=</span> <span class="n">BinaryStar</span><span class="p">()</span>

        <span class="c1"># get the data for the binary</span>
        <span class="k">if</span> <span class="n">run</span><span class="o">.</span><span class="n">binary_history</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">n_steps</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">binary_history</span><span class="p">[</span><span class="s2">&quot;age&quot;</span><span class="p">])</span> <span class="k">if</span> <span class="n">history</span> <span class="k">else</span> <span class="mi">1</span>
            <span class="n">bh_colnames</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">binary_history</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">names</span>
            <span class="k">for</span> <span class="n">attr</span> <span class="ow">in</span> <span class="n">BINARYPROPERTIES</span><span class="p">:</span>
                <span class="n">colname</span> <span class="o">=</span> <span class="n">BINARY_ATTRIBUTES_FROM_HISTORY</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">attr</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">colname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">colname</span> <span class="ow">in</span> <span class="n">bh_colnames</span><span class="p">:</span>
                    <span class="n">final_value</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_values</span><span class="p">[</span><span class="n">colname</span><span class="p">]</span>
                    <span class="k">if</span> <span class="n">history</span><span class="p">:</span>
                        <span class="n">col_history</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">binary_history</span><span class="p">[</span><span class="n">colname</span><span class="p">])</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">final_value</span><span class="p">]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">final_value</span> <span class="o">=</span> <span class="kc">None</span>
                    <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span> <span class="o">*</span> <span class="n">n_steps</span>
                <span class="k">assert</span> <span class="n">n_steps</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">col_history</span><span class="p">)</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">attr</span> <span class="o">+</span> <span class="s2">&quot;_history&quot;</span><span class="p">,</span> <span class="n">col_history</span><span class="p">)</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">attr</span><span class="p">,</span> <span class="n">final_value</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">binary</span>    <span class="c1"># if no binary history, return defaults</span>

        <span class="c1"># get the data for each companion star</span>
        <span class="k">for</span> <span class="n">star_history</span><span class="p">,</span> <span class="n">star</span><span class="p">,</span> <span class="n">prefix</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">([</span><span class="n">run</span><span class="o">.</span><span class="n">history1</span><span class="p">,</span> <span class="n">run</span><span class="o">.</span><span class="n">history2</span><span class="p">],</span>
                                              <span class="p">[</span><span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="p">],</span>
                                              <span class="p">[</span><span class="s2">&quot;S1&quot;</span><span class="p">,</span> <span class="s2">&quot;S2&quot;</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">star_history</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">h_colnames</span> <span class="o">=</span> <span class="n">star_history</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">names</span>
                <span class="k">for</span> <span class="n">attr</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
                    <span class="c1"># get the corresponding column name (default=same name)</span>
                    <span class="n">colname</span> <span class="o">=</span> <span class="n">STAR_ATTRIBUTES_FROM_STAR_HISTORY</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">attr</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">colname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">colname</span> <span class="ow">in</span> <span class="n">h_colnames</span><span class="p">:</span>
                        <span class="n">final_value</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_values</span><span class="p">[</span><span class="n">prefix</span> <span class="o">+</span> <span class="s2">&quot;_&quot;</span> <span class="o">+</span> <span class="n">colname</span><span class="p">]</span>
                        <span class="k">if</span> <span class="n">history</span><span class="p">:</span>
                            <span class="n">col_history</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">star_history</span><span class="p">[</span><span class="n">colname</span><span class="p">])</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">final_value</span><span class="p">]</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">final_value</span> <span class="o">=</span> <span class="kc">None</span>
                        <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span> <span class="o">*</span> <span class="n">n_steps</span>
                    <span class="k">assert</span> <span class="n">n_steps</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">col_history</span><span class="p">)</span>
                    <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span> <span class="o">+</span> <span class="s2">&quot;_history&quot;</span><span class="p">,</span> <span class="n">col_history</span><span class="p">)</span>
                    <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span><span class="p">,</span> <span class="n">final_value</span><span class="p">)</span>

        <span class="c1"># set metallicities (if defined in the track)...</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">metallicity</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">initial_values</span><span class="p">[</span><span class="s2">&quot;Z&quot;</span><span class="p">]</span>
        <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
            <span class="n">metallicity</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="c1"># ...and other star parameters taken from the binary history</span>
        <span class="k">for</span> <span class="n">star_index</span><span class="p">,</span> <span class="n">star</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">([</span><span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="p">]):</span>
            <span class="n">star</span><span class="o">.</span><span class="n">metallicity</span> <span class="o">=</span> <span class="n">metallicity</span>
            <span class="n">star</span><span class="o">.</span><span class="n">metallicity_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">metallicity</span><span class="p">]</span> <span class="o">*</span> <span class="n">n_steps</span>
            <span class="k">for</span> <span class="n">attr</span><span class="p">,</span> <span class="n">colnames</span> <span class="ow">in</span> <span class="n">STAR_ATTRIBUTES_FROM_BINARY_HISTORY</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="n">colname</span> <span class="o">=</span> <span class="n">colnames</span><span class="p">[</span><span class="n">star_index</span><span class="p">]</span>
                <span class="n">final_value</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_values</span><span class="p">[</span><span class="n">colname</span><span class="p">]</span>
                <span class="k">if</span> <span class="n">history</span><span class="p">:</span>
                    <span class="n">col_history</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">binary_history</span><span class="p">[</span><span class="n">colname</span><span class="p">])</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">final_value</span><span class="p">]</span>
                <span class="k">assert</span> <span class="n">n_steps</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">col_history</span><span class="p">)</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span><span class="p">,</span> <span class="n">final_value</span><span class="p">)</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span> <span class="o">+</span> <span class="s2">&quot;_history&quot;</span><span class="p">,</span> <span class="n">col_history</span><span class="p">)</span>

        <span class="c1"># update eccentricity</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">eccentricity</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">eccentricity_history</span> <span class="o">=</span> <span class="p">[</span><span class="mf">0.0</span><span class="p">]</span> <span class="o">*</span> <span class="n">n_steps</span>

        <span class="c1"># update star states</span>
        <span class="n">n_history</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">time_history</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">star</span><span class="p">,</span> <span class="n">track</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">([</span><span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="p">],</span>
                               <span class="p">[</span><span class="n">run</span><span class="o">.</span><span class="n">history1</span><span class="p">,</span> <span class="n">run</span><span class="o">.</span><span class="n">history2</span><span class="p">]):</span>
            <span class="n">is_CO</span> <span class="o">=</span> <span class="n">track</span> <span class="ow">is</span> <span class="kc">None</span>
            <span class="n">state_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">check_state_of_star</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">star_CO</span><span class="o">=</span><span class="n">is_CO</span><span class="p">)</span>
                             <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">n_history</span><span class="p">)]</span>
            <span class="n">star</span><span class="o">.</span><span class="n">state_history</span> <span class="o">=</span> <span class="n">state_history</span>
            <span class="n">star</span><span class="o">.</span><span class="n">state</span> <span class="o">=</span> <span class="n">state_history</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="c1"># update binary state, event and MT case</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">state_history</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">event_history</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">mass_transfer_case_history</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">n_history</span><span class="p">):</span>  <span class="c1"># step-by-step: previous states matter!</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">get_binary_state_and_event_and_mt_case</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="n">i</span><span class="p">)</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">state</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">event</span><span class="p">,</span> <span class="n">binary</span><span class="o">.</span><span class="n">mass_transfer_case</span> <span class="o">=</span> <span class="n">result</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">state_history</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">state</span><span class="p">)</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event</span><span class="p">)</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">mass_transfer_case_history</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">mass_transfer_case</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">profiles</span><span class="p">:</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">star_1</span><span class="o">.</span><span class="n">profile</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_profile1</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">star_2</span><span class="o">.</span><span class="n">profile</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_profile2</span>

        <span class="k">return</span> <span class="n">binary</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>